/*  GP2Xengine 
    Copyright (C) 2006  Hermes/PS2Reality  * Made in Vallecas - Madrid (Spain)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/





#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <math.h>
#include <time.h>
#include <unistd.h>
#include <dirent.h>

//#include <gp2xminilib.h>
#include "minimal.h"
#include "cpuctrl.h"
#include "wav.h"

extern char *MY_filename;
char * get_name(char *name);

int skip_wave_sound=0;
unsigned gp2x_nKeys=0;

unsigned char *XBuf;

int Debug=0;
int vmode=0;

#define WIDTH (320+64)
#define HEIGHT 256
#define KEYPAUSE 100 /* Pausa en milisegundos antes de leer el teclado (necesario tras aplicar mmu hack de Squidge)*/

int volume=50;
int delay_volume=0;

int auto_fire=0;

/*********************************************************************/
/* GP2X System                                                       */
/*********************************************************************/

int gp2x_speed=166;
void set_speed_clock()
{
  int div;
  
  div=(gp2x_speed*14)/200;
  if(div>63) div=63;
  
  set_display_clock_div(64 | div /*(16+8*(gp2x_speed>=220))*/);
  set_FCLK(gp2x_speed);set_DCLK_Div(0);set_920_Div(0);
}

void SetVideoScaling(int pixels,int width,int height)
{
static int pixels2=0,width2=0,height2=0;
if(width2!=width || height2!=height)
	{
    gp2x_video_RGB_setscaling(width,height);
	width2=width;height2!=height;
	}
if(pixels2!=pixels)
    {
	pixels2=pixels;
	gp2x_video_RGB_width_screen(pixels);
	}

}

/*********************************************************************/
/* Save/Load configuration of gp2xengine                             */
/*********************************************************************/


typedef struct
{
int video_inverted;
int  bright;
unsigned char A,B,X,Y,L,R,noused1,noused2;
unsigned noused3[16]; // for future use
} 
MCONFIG;

MCONFIG mconfig={0,0,1,2,1,2,0,0};

void load_mconfig()
{FILE *fp;
fp=fopen("/mnt/sd/roms/pcengine/saves/gp2xengine.cfg","rb");
if(fp==NULL) return;
fread(&mconfig, 1, sizeof(mconfig), fp);
fclose(fp);
}
void save_mconfig()
{
FILE *fp;
fp=fopen("/mnt/sd/roms/pcengine/saves/gp2xengine.cfg","wb");
if(fp==NULL) return;
fwrite(&mconfig, 1, sizeof(mconfig), fp);
fclose(fp);
sync();
}




/****************************************************************************************************************************************/
// PANTALLA
/****************************************************************************************************************************************/

extern unsigned char msx[];  // define la fuente externa usada para dibujar letras y numeros 

unsigned char COLORFONDO=0; // color de fondo (vaya noticia :P)

void set_mypalette()
{
gp2x_video_RGB_color8(0x00,0x40,0x00,0);
gp2x_video_RGB_color8(0x00,0xff,0x00,1);
gp2x_video_RGB_color8(0xff,0xff,0xff,2);
gp2x_video_RGB_color8(0xff,0x00,0x00,3);
gp2x_video_RGB_color8(0xff,0xff,0x00,4);
gp2x_video_RGB_color8(0x00,0xff,0xff,5);
gp2x_video_RGB_color8(0x00,0x00,0x00,6);
gp2x_video_RGB_color8(255,255,255,255);
gp2x_video_RGB_setpalette();
}

void set_emupalette()
{
int i;


unsigned  ga=(unsigned) (255.0*((float) (1024+170*(mconfig.bright & 3)))/1024.0);
for(i=0;i<255;i++)
  {
  
   unsigned r=((i&0x1c)<<3),g=(((i&0xe0)>>2)<<2),b=(((i&3)<<6));
   r=(r*ga)>>8;if(r>255) r=255;
   g=(g*ga)>>8;if(g>255) g=255; 
   b=(b*ga)>>8;if(b>255) b=255;

   gp2x_video_RGB_color8(r,g,b,i);

 
   
  }
/*
for(i=0;i<255;i++)
gp2x_video_RGB_color8((i&0x1c)<<3,(((i&0xe0)>>2)<<2),(((i&3)<<6)),i);*/
gp2x_video_RGB_color8(255,255,255,i);
gp2x_video_RGB_setpalette();
}


void ClearScreen(unsigned char c) // se usa para 'borrar' la pantalla virtual con un color
{
int n;

for(n=0;n<320*240;n++)
	{
	gp2x_screen8[n]=c;
	}

}


void v_putchar( unsigned x, unsigned y, unsigned char color, unsigned char ch) // rutina usada para dibujar caracteres (coordenadas de 8x8)
{
   int 	i,j,v;
   unsigned char	*font;
  unsigned char col,col2;
   if(x>=40 || y>=30) return;

col=color;
col2=COLORFONDO;

   v=(y*320*8);
   font = &msx[ (int)ch * 8];
   for (i=0; i < 8; i++, font++)
		{  
		 for (j=0; j < 8; j++)
          {
          if ((*font & (128 >> j)))
			  { 
               gp2x_screen8[v+(((x<<3)+j))]=col;
			  }
			else gp2x_screen8[v+(((x<<3)+j))]=col2;
          }
	  v+=320;
	 }
 
}

// display array of chars

int v_breakcad=40;
int v_forcebreakcad=0;
void v_putcad(int x,int y,unsigned color,char *cad)  // dibuja una cadena de texto
{
int n=0;	
while(cad[0]!=0) {if(n==v_breakcad) break; v_putchar(x,y,color,cad[0]);cad++;x++;n++;}
if(v_forcebreakcad)
	{
	while(1) {if(x>=40 || n==v_breakcad) break; v_putchar(x,y,color,' ');cad++;x++;n++;}
	}
}


void m_putchar( unsigned x, unsigned y, unsigned char color, unsigned char ch,int width) // rutina usada para dibujar caracteres (coordenadas de 8x8)
{
   int 	i,j,v;
   unsigned char	*font;
  unsigned char col,col2;
   if(x>=40 || y>=30) return;

col=color;
col2=7;//COLORFONDO;

   v=(y*width*8);
   font = &msx[ (int)ch * 8];
   for (i=0; i < 8; i++, font++)
		{  
		 for (j=0; j < 8; j++)
          {
          if ((*font & (128 >> j)))
			  { 
              XBuf[v+(((x<<3)+j))]=col;
			  }
			else XBuf[v+(((x<<3)+j))]=col2;
          }
	  v+=width;
	 }
 
}

// display array of chars

void m_putcad(int x,int y,unsigned color,char *cad,int width)  // dibuja una cadena de texto
{
int n=0;	
while(cad[0]!=0) {if(n==v_breakcad) break; m_putchar(x,y,color,cad[0],width);cad++;x++;n++;}
if(v_forcebreakcad)
	{
	while(1) {if(x>=40 || n==v_breakcad) break; m_putchar(x,y,color,' ',width);cad++;x++;n++;}
	}
}



static int vwidth=320,vheight=240;
int scount=0;
int swap_screen=0;
static old_W=0;
int video_is_inverted=0;
int osd_volumen=0;

/*********************************************************************/
//  saving bitmap (photo mode)
/*********************************************************************/

int make_photo=0; // variable asignada cuando queremos hacer una foto

int photo_number=0;  // contador de numero de foto
char photo_name[256]; // nombre del fichero

typedef struct{
	
	 
	unsigned size;
	unsigned reserved; 
	unsigned offset; 

	unsigned header_size; 
	unsigned width ; 
	unsigned height; 
	unsigned short planes;  
	unsigned short bpp; 
	unsigned compression; 
	unsigned image_size; 
	unsigned ppm[2]; 
	unsigned color_info[2]; 

} bmp_header;
bmp_header bmph;

struct 
{
unsigned char b,g,r,a;
} prgba;

void save_bmp(char *name,unsigned char *punt, int ancho, int alto, int align)
{
FILE *fp;
int i;
fp=fopen(name,"wb");
if(fp==NULL) return;
fputc('B',fp);
fputc('M',fp);
bmph.reserved=0;
bmph.size=54+ancho*alto+256*4;
bmph.offset=256*4+54;
bmph.header_size=40;
bmph.width=ancho;
bmph.height=alto;
bmph.planes=1;
bmph.bpp=8;
bmph.compression=0;
bmph.image_size=ancho*alto;
bmph.ppm[0]=bmph.ppm[1]=0;
bmph.color_info[0]=0; // 0 es 256
bmph.color_info[1]=0;
fwrite(&bmph, 1, 52, fp);
prgba.a=0;
for(i=0;i<255;i++)
  {
  
   prgba.r=((i&0x1c)<<3);
   prgba.g=(((i&0xe0)>>2)<<2);
   prgba.b=(((i&3)<<6));
  fwrite(&prgba, 1, 4, fp);
  }
prgba.r=255;
prgba.g=255;
prgba.b=255;
fwrite(&prgba, 1, 4, fp);
for(i=1;i<=alto;i++)
	{
	fwrite(punt+(alto-i)*align, 1, ancho, fp);
	}
fclose(fp);
sync();
}




/*********************************************************************/
// funciones llamadas por PCE.C
/*********************************************************************/

char cad[256];
int FPS=0;
unsigned oldtime=0, curtime;
int count_fps=0;
int skip_fps=2;

void PutImage(int X, int Y, int W, int H)
{
int time1;

 volatile unsigned char *source;
 volatile unsigned char *dest;
 unsigned char *dest_p;
volatile unsigned *source2;
 volatile  unsigned  *dest2;
 int invert_video=0;
 #if 0  // via software
 int i,n,m;
 int C,C2,y2,w,w2;
 int sm_w;
 
 int dx;
 short sum_sc[320];
 #else
int h,w,dw,dh;
 volatile int n,m;
 volatile int w4;
 #endif
 if (Debug) return;
 //gp2x_video_waitvsync();

// si cambia el ancho, borra la pantalla
 if(old_W!=W) {swap_screen=0;memset(gp2x_screen8,0,vwidth*vheight);old_W=W;}

swap_screen++;swap_screen&=1;
if(swap_screen!=1) return;  // salta un frame

n=count_fps;
count_fps++;



//swap_screen=0;


curtime=clock()/(CLOCKS_PER_SEC/1000);
if((curtime-oldtime)>=1000)
	{
	oldtime=curtime;
	FPS=count_fps;count_fps=0;
/*	if(FPS>30) skip_fps*=2; else skip_fps/=2;
	if(skip_fps<2)skip_fps=2;*/
	}

 if(make_photo==1) // saca una foto
	{
	char *mname;
	mname=get_name(MY_filename);
	// obten nombre sin extension
	n=0;while(mname[n]!=0) n++;
	while(n>0) {if(mname[n]=='.') {mname[n]=0;break;} n--;}

	make_photo=2;
	sprintf(photo_name,"/mnt/sd/roms/pcengine/img/%s-%3.3u.bmp",mname,photo_number);
	save_bmp(photo_name, XBuf + Y * WIDTH + X, W, H, WIDTH);
	photo_number++;memset(gp2x_screen8,0,vwidth*vheight);
    SetVideoScaling(vwidth,vwidth,vheight);return;
	}
if(osd_volumen)
	{sprintf(cad,"Volume: %u%% ",volume);
    m_putcad((X+7)/8,(Y+7)/8,255,cad,WIDTH);
	osd_volumen--;
	}
// PROCEDIMIENTO NUEVO scaling por Hardware

if(X>32 && mconfig.video_inverted==1) invert_video=1; // decide si se usa la pantalla en vertical u horizontal
else {invert_video=0;}
if(mconfig.video_inverted==2) invert_video=2;
if(invert_video==1)
	{volatile int H2,W2;
	
	video_is_inverted=1; 
	W2=W;
    
	dest = &gp2x_screen8[0];
	source = XBuf + Y * WIDTH + X;
	if(H>W) {H2=W2;W=(H+3)/4*4;} else H2=H;

	dest_p=dest+(H-1);
	for(n=0;n<H;n++)
	{
	dest=dest_p;
	 for(m=0;m<W2;m++)
		{
		 *dest=*source++;
		dest+=W;
		}
	source+=WIDTH-W2;dest_p--;
	}
	w=(256*W2)/320;
	
    SetVideoScaling(W,H,w);

	return;
	}
video_is_inverted=0;
dw=(vwidth-W)/2;dh=(vheight-H)/2;
if(dw<0) dw=0;
if(dh<0) dh=0;
w=W; if(W<vwidth) w=vwidth;
h=H; if(H<vheight) h=vheight;
dh*= w;

dest = &gp2x_screen8[dh+dw];
 source = XBuf + Y * WIDTH + X;
 

if(invert_video==2)
	{
	video_is_inverted=2;
	 dest_p= &gp2x_screen8[w*(h-1)-w+W-dh+dw];
	 for(n=0;n<H;n++)
	{
	
	 dest=dest_p;
	 for(m=0;m<W;m++) *dest--=*source++;
	//memcpy(dest,source,W);
	source+=WIDTH-W;
	dest_p-=w;
	}
	}
else
	{
	w4=W>>2;
	 for(n=0;n<H;n++)
	{
	 dest2=(unsigned *) dest;
	 source2=(unsigned *) source;
	 for(m=0;m<w4;m++) *dest2++=*source2++;
	//memcpy(dest,source,W);
	source+=WIDTH;
	dest+=w;
	}
	}

 
 SetVideoScaling(w,w,h);



#if 0 // procedimiento anterior por software
skip_wave_sound=1; 

vwidth=320; 


 w=W;w2=0;
 if (W>vwidth) {
 	w=vwidth;w2=W-vwidth;
	m=0;C=0;Y=0;
	for(n=0;n<320;n++) {sum_sc[n]=m;m++;C+=w2;if(C>=320) {m++;C-=320;}} // stretch offset
	
 }

sm_w=vwidth;
dest = &gp2x_screen8[/*(vheight-H)/2 * vwidth +*/ (vwidth-w)/2];
 source = XBuf + Y * WIDTH + X;
 source2=(unsigned *) source;
 dest2=(unsigned *) dest;
 //if(swap)  {dest +=vwidth;source += WIDTH;}

 C2=0;
 for( i =0; i < vheight ; i++ )
  {
	m=0;C=0;
	if (W>vwidth)
      {for(n=0;n<w;n++) {dest[n]=source[sum_sc[n]];}dest += sm_w;source += WIDTH;C2+=H-vheight;if(C2>=vheight) {C2-=vheight;source += WIDTH;}}
	else
	  {for(n=0;n<w>>2;n++) 
		{dest2[n]=source2[n];}
	     dest2 += sm_w>>2;
		 source2 += WIDTH/4;C2+=H-vheight;
		 if(C2>=vheight) {C2-=vheight;source2 += WIDTH>>2;}} // fast
   
  
  }

skip_wave_sound=0;
 return;
#endif
 

}

int InitMachine(void)
{
swap_screen=0;
XBuf = malloc(sizeof(char) * WIDTH * HEIGHT);
if(!XBuf) return 0;

memset(XBuf,0,WIDTH * HEIGHT);

gp2x_video_RGB_noflip(0); // single buffer screen

ClearScreen(COLORFONDO);gp2x_video_waitvsync();
InitSound(1);

return 1;
	
	
}

void TrashMachine(void)
{
	
if (XBuf) free(XBuf);XBuf=0;

StopSound();


}


#define	JOY_A	1
#define	JOY_B	2
#define	JOY_SELECT	4
#define	JOY_START	8
#define	JOY_UP	0x10
#define	JOY_DOWN	0x40
#define	JOY_LEFT	0x80
#define	JOY_RIGHT	0x20


int Config_SCR();
int Joysticks(void)
{
int v=0;
gp2x_nKeys=gp2x_joystick_read();
make_photo &= 0xfffffffe;
auto_fire++;
if(video_is_inverted==2)
	{
	if(mconfig.A)
	{
	if(gp2x_nKeys & GP2X_VOL_UP) 
		{if(mconfig.A & 4) {if(mconfig.A==7) v|=1; else if(auto_fire & 4) v|=mconfig.A & 3;} else v|=mconfig.A & 3;}
	}
if(mconfig.B)
	{
	if(gp2x_nKeys & GP2X_VOL_DOWN) 
		{if(mconfig.B & 4) {if(mconfig.B==7) v|=2; else if(auto_fire & 4) v|=mconfig.B & 3;} else v|=mconfig.B & 3;}
	}
	}
else
{
if(mconfig.A)
	{
	if(gp2x_nKeys & GP2X_A) 
		{if(mconfig.A & 4) {if(mconfig.A==7) make_photo|=1; else if(auto_fire & 4) v|=mconfig.A & 3;} else v|=mconfig.A & 3;}
	}
if(mconfig.B)
	{
	if(gp2x_nKeys & GP2X_B) 
		{if(mconfig.B & 4) {if(mconfig.B==7) make_photo|=1; else if(auto_fire & 4) v|=mconfig.B & 3;} else v|=mconfig.B & 3;}
	}
if(mconfig.X)
	{
	if(gp2x_nKeys & GP2X_X) 
		{if(mconfig.X & 4) {if(mconfig.X==7) make_photo|=1; else if(auto_fire & 4) v|=mconfig.X & 3;} else v|=mconfig.X & 3;}
	}
if(mconfig.Y)
	{
	if(gp2x_nKeys & GP2X_Y) 
		{if(mconfig.Y & 4) {if(mconfig.Y==7) make_photo|=1; else if(auto_fire & 4) v|=mconfig.Y & 3;} else v|=mconfig.Y & 3;}
	}
}
if(mconfig.L)
	{
	if(gp2x_nKeys & GP2X_L) 
		{if(mconfig.L & 4) {if(mconfig.L==7) make_photo|=1; else if(auto_fire & 4) v|=mconfig.L & 3;} else v|=mconfig.L & 3;}
	}
if(mconfig.R)
	{
	if(gp2x_nKeys & GP2X_R) 
		{if(mconfig.R & 4) {if(mconfig.R==7) make_photo|=1; else if(auto_fire & 4) v|=mconfig.R & 3;} else v|=mconfig.R & 3;}
	}

if(make_photo>1)  // si la foto se ha hecho, evita autorrepeticiones 
	{
	if((make_photo & 1)==0) make_photo=0;
	}

/*
if((gp2x_nKeys & (GP2X_A | GP2X_X)))v|=JOY_A;
if((gp2x_nKeys & (GP2X_B | GP2X_Y)))v|=JOY_B;
*/
if((gp2x_nKeys & GP2X_SELECT))v|=JOY_SELECT;
if((gp2x_nKeys & GP2X_START))v|=JOY_START;
if(video_is_inverted==1)
 {
 if((gp2x_nKeys & GP2X_RIGHT))v|=JOY_UP;
 if((gp2x_nKeys & GP2X_LEFT))v|=JOY_DOWN;
 if((gp2x_nKeys & GP2X_UP))v|=JOY_LEFT;
 if((gp2x_nKeys & GP2X_DOWN))v|=JOY_RIGHT;
 }
else 
if(video_is_inverted==2)
 {
 if((gp2x_nKeys & GP2X_X))v|=JOY_UP;
 if((gp2x_nKeys & GP2X_Y))v|=JOY_DOWN;
 if((gp2x_nKeys & GP2X_B))v|=JOY_LEFT;
 if((gp2x_nKeys & GP2X_A))v|=JOY_RIGHT;
 
 }
else
{
 if((gp2x_nKeys & GP2X_UP))v|=JOY_UP;
 if((gp2x_nKeys & GP2X_DOWN))v|=JOY_DOWN;
 if((gp2x_nKeys & GP2X_LEFT))v|=JOY_LEFT;
 if((gp2x_nKeys & GP2X_RIGHT))v|=JOY_RIGHT;
 }

if((gp2x_nKeys & GP2X_L) /*&& (gp2x_nKeys & GP2X_R)*/ && (gp2x_nKeys & GP2X_SELECT)) {v=0;if(Config_SCR()) v|=0x10000;}

if(video_is_inverted!=2)
{
if(gp2x_nKeys & (GP2X_VOL_UP | GP2X_VOL_DOWN))
	{
	osd_volumen=50;
	if(delay_volume) delay_volume--;
	else
		{
		if(gp2x_nKeys & GP2X_VOL_UP)
			{delay_volume=20;volume+=10;if(volume>100) volume=100;gp2x_sound_volume(volume,volume);}
		if(gp2x_nKeys & GP2X_VOL_DOWN)
			{delay_volume=20;volume-=10;if(volume<0) volume=0;gp2x_sound_volume(volume,volume);}
	    }
	}
	else delay_volume=0;
}
return v;
}





/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// SONIDO
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int		ds_nBits		= 16;
int		ds_nChannels	= 2;
int		ds_nSampleRate	= 22050; // no modificar! (esta frecuencia es duplicada para corresponder con 44100)
int		ds_nLockLatency	= 40;



int di_sound=1;



int InitDSound()
{
}

int StartSound(void)
{ di_sound=0;gp2x_sound_pause(0) ;
}

int ReleaseDSound(void)
{
}
int ReleaseSoundBuffer(void)
{
}
int StopSound(void)
{ di_sound=1;gp2x_sound_pause(1) ;
}



void gp2x_sound_frame(void *unused, void *stream, int samples)
{

int n;
short *pu;

pu=stream;
if(di_sound==1)
	{
	for(n=0;n<(samples);n++)
		{*pu++=0;*pu++=0;}
	return;
	}
	


for(n=0;n<6;n++) {WriteSoundData(pu, n, samples/*<<1*/);}
wav_mix_samples(pu,samples<<1);
}


/**************************************************************/
// SONIDO WAV
/**************************************************************/


pthread_t       wave_sound_thread=0;

void wav_loop();

int  wave_sound_thread_exit=0;
//int i_need_a_wav_loop=0;
void * wave_sound_play(void * p) // hilo de lectura de ficheros wav
{ int usec=1000000/12;
while(!wave_sound_thread_exit)
	{
     usleep(usec);
    usec=1000000/50;
    if(skip_wave_sound!=0) continue;
	 usec=1000000/12;
	wav_loop();
	//i_need_a_wav_loop=1;
	}
return NULL;
}
////////////////////////////////////////////////////////////////////////


/***************************************************************************/
// seleccion de roms y otras pantallas del emu 
/***************************************************************************/


#define MAX_ENTRY 512

char files[MAX_ENTRY][257];
char is_directory[MAX_ENTRY];
int nfiles=0;
int ndirs=0;
char path_rom[257]="/mnt/sd/roms/pcengine/";

int is_ext(char *a,char *b) // compara extensiones
{
int n,m;
m=0;n=0;


while(a[n]!=0) {if(a[n]=='.') m=n; n++;}
n=0;
while(b[n]!=0) {if(a[m]!=b[n]) return 0; m++; n++;}
if(a[m]==0) return 1;
return 0;
}

void read_list_rom(unsigned char *dirname)
{DIR *fd;
static struct dirent *direntp;
static unsigned char *olddirname=NULL;
static char swap[257],sw;
int n,m,f;
if(((int) dirname)==-1) dirname=olddirname;
else olddirname=dirname;
ndirs=0;
nfiles = 0;
if(dirname)
	{if(dirname[0] == '.') {sprintf(swap, "%s", path_rom);dirname=0;} // raiz
     else sprintf(swap, "%s%s/", path_rom, dirname);
	
	}
else sprintf(swap, "%s", path_rom);


fd = opendir(swap);

if(fd != NULL) 
	{
	
	while(nfiles < MAX_ENTRY)
		{is_directory[nfiles]=0;
		direntp=readdir(fd);
	    if(direntp==NULL) break;
		if(direntp->d_name[0] == '.' && direntp->d_name[1]==0) continue;
        
		sprintf(&files[nfiles][0], "%s%s", swap, direntp->d_name);
	   
		if( direntp->d_type & DT_DIR) 
			{if((dirname==0 && direntp->d_name[0] != '.') || (direntp->d_name[0] == '.' && dirname!=0)) {ndirs++;is_directory[nfiles]=1; }
		      else continue; 
		    }
		else 
		
		if(!(is_ext(&files[nfiles][0],".pce") || is_ext(&files[nfiles][0],".PCE") || is_ext(&files[nfiles][0],".toc") || is_ext(&files[nfiles][0],".TOC") 
			|| is_ext(&files[nfiles][0],".iso") || is_ext(&files[nfiles][0],".ISO") || is_ext(&files[nfiles][0],".sav")
			|| is_ext (&files[nfiles][0], ".bz2") || is_ext (&files[nfiles][0], ".BZ2")
		   ) ) continue;
		
		nfiles++;
		}
	
	closedir(fd);	
	}
	

for(n=0;n<(nfiles);n++) //ordena
for(m=n+1;m<nfiles;m++)
	{f=0;
 
	
		if(is_directory[m]==1 && is_directory[n]==0) f=1;
	    if(f==0) if(is_directory[m]==is_directory[n]) if(strcmp(&files[m][0],&files[n][0])<0) f=1;
		if(f)
		{f=0;
		sw=is_directory[m];
		is_directory[m]=is_directory[n];
		is_directory[n]=sw;
		memcpy(swap,&files[m][0],256);
		memcpy(&files[m][0],&files[n][0],256);
		memcpy(&files[n][0],swap,256);
		}
	}

} 

char * get_name_short(char *name) // devuelve el nombre del fichero recortado a 20 caracteres
{
static unsigned char name2[32];
int n,m;
m=0;n=-1;

while(name[m]!=0) {if(name[m]=='/') n=m;m++;}
n++;
for(m=0;m<20;m++)
	{
	name2[m]=name[n];
	if(name[n]==0) break;
	n++;
	}
name2[m]=0;
return name2;
}

char * get_name(char *name) // devuelve el nombre del fichero completo
{
static unsigned char name2[256];
int n,m;
m=0;n=-1;

while(name[m]!=0) {if(name[m]=='/') n=m;m++;}
n++;
for(m=0;m<255;m++)
	{
	name2[m]=name[n];
	if(name[n]==0) break;
	n++;
	}
name2[m]=0;
return name2;
}


int never_run_one_rom=1; // se usa para evitar que se reentre con el boto B sin haber cargado una rom primero

int compress_rom(char *name);

int get_rom()
{
static int init=1;
static  int posfile=0;
unsigned char cad[256];
int n,m,y,f;
static int bright=1;
int old_speed=gp2x_speed;
unsigned new_key=0,old_key=0;
set_mypalette();
if(init)
	{
   read_list_rom(0);if(nfiles)  init=0; else init=1;
   posfile=0;
	}

while(gp2x_nKeys & (GP2X_X | GP2X_PUSH)) gp2x_nKeys=gp2x_joystick_read(); // para quieto!!

usleep(KEYPAUSE); /* Pausa en milisegundos antes de leer el teclado (necesario tras aplicar mmu hack de Squidge)*/

if(posfile>=nfiles) posfile=0;
COLORFONDO=0;  gp2x_video_RGB_flip(0);
f=0;
while(1)
	{gp2x_video_waitvsync();gp2x_video_RGB_flip(0);ClearScreen(COLORFONDO);
    sprintf(cad,"ROM LIST (%u)",nfiles-ndirs);
    v_putcad(0,1,4,cad);
    m=0;

	for(n=posfile-10;n<posfile+25;n++)
		{if(n<0) continue;
	     if(n>=nfiles) break;
		 if(m>24) break;
		 if(n==posfile) COLORFONDO=1; else COLORFONDO=6;
		v_breakcad=19;v_forcebreakcad=1;
		if(is_directory[n])
			{
			sprintf(cad,"<%s>",get_name_short(&files[n][0]));
			v_putcad(0,m+3,5,cad);
			}
		else v_putcad(0,m+3,2,get_name_short(&files[n][0]));
		v_breakcad=40;v_forcebreakcad=0;
		COLORFONDO=0;
		 m++;
		}
	
	//////////////
	for(;m<25;n++)
		{
		COLORFONDO=6;
		v_breakcad=19;v_forcebreakcad=1;
		v_putcad(0,m+3,2," ");
		v_breakcad=40;v_forcebreakcad=0;
		COLORFONDO=0;
		 m++;
		}
	//////////////

    y=6;
	v_putcad(20,y,4,"Press SELECT to Exit");y+=2;
	v_putcad(20,y,4,"Press A/X to Play");y+=2;
    v_putcad(20,y,4,"Press L/R for speed");y+=2;
	v_putcad(20,y,4,"Press B to return  ");y+=2;
	v_putcad(20,y,4,"Press START to create");y+=1;
	v_putcad(20,y,4,"compressed .PCE files");y+=2;
	sprintf(cad,"speed %uMhz",gp2x_speed);
	y+=2;
    v_putcad(20+4,y,5,cad);y+=2;

    gp2x_nKeys=gp2x_joystick_read();
	
	new_key=gp2x_nKeys & (~old_key);
	old_key=gp2x_nKeys;
    if(!(old_key  & (GP2X_UP | GP2X_DOWN))) f=0;
	if(old_key  & GP2X_UP)
		{
		if(f==0) f=2;
		else if(f & 1) f=2;
		else {f+=2;if(f>40) {f=34;new_key|=GP2X_UP;}}
		}
	if(old_key  & GP2X_DOWN)
		{
		if(f==0) f=1;
		else if(!(f & 1)) f=1;
		else {f+=2;if(f>41) {f=35;new_key|=GP2X_DOWN;}}
		}
		
	

if(nfiles>0) if(new_key & (GP2X_A | GP2X_PUSH | GP2X_X)) 
		{
		
		if(!is_directory[posfile]) {if(old_speed!=gp2x_speed) set_speed_clock();return posfile;}
          else
			{
			 read_list_rom(get_name(&files[posfile][0]));if(nfiles)  init=0; else init=1;posfile=0;
			}
		}

if(never_run_one_rom==0 && (new_key & (GP2X_B))) {         // continua el juego
									if(old_speed!=gp2x_speed) set_speed_clock();
									
									memset(XBuf,0,WIDTH * HEIGHT);

									gp2x_video_RGB_noflip(0); // single buffer screen

									ClearScreen(COLORFONDO);gp2x_video_waitvsync();
									return -666;
									}


if(new_key & GP2X_START)
		{
	    for(n=0;n<nfiles;n++)
			{
			ClearScreen(0);
    
			v_putcad((40-22)>>1,10,4,"COMPRESSING .PCE FILES");
			sprintf(cad,"%% %u",(n*100)/nfiles);
			v_putcad(18,12,5,cad);
			v_putcad((40-17)>>1,15,2,"Press Y to Cancel");
			gp2x_video_waitvsync();gp2x_video_RGB_flip(0);

			if(!is_directory[n]) 
				if(is_ext(&files[n][0],".pce") || is_ext(&files[n][0],".PCE")) if(compress_rom(&files[n][0])) break;
			gp2x_nKeys=gp2x_joystick_read();
			if(gp2x_nKeys  & GP2X_Y) break;
			
			}
		read_list_rom(-1);if(nfiles)  init=0; else init=1;posfile=0;
		}


if(new_key & GP2X_R)
		{
		switch(gp2x_speed)
			{
			case 150:gp2x_speed=166;break; 
			case 166:gp2x_speed=180;break; 
			case 180:gp2x_speed=200;break; 
			case 200:gp2x_speed=220;break; 
			case 220:gp2x_speed=240;break; 
			case 240:gp2x_speed=250;break; 
			case 250:gp2x_speed=266;break;
			case 266:gp2x_speed=150;break; 
			}
		
		
		}
if(new_key & GP2X_L)
		{
		switch(gp2x_speed)
			{
			case 150:gp2x_speed=266;break;
			case 166:gp2x_speed=150;break; 
			case 180:gp2x_speed=166;break; 
			case 200:gp2x_speed=180;break; 
			case 220:gp2x_speed=200;break; 
			case 240:gp2x_speed=220;break; 
			case 250:gp2x_speed=240;break; 
			case 266:gp2x_speed=250;break; 
			
			}
		
		
		}

if((new_key & GP2X_UP)) {posfile--;if(posfile<0) posfile=nfiles-1;}
if((new_key & GP2X_DOWN)){posfile++;if(posfile>=nfiles) posfile=0;} 
if(new_key & GP2X_SELECT) {return -1;}

	}

return -1;
}

void credits()
{

int y;
int count=25*10;

set_mypalette();
COLORFONDO=0;  gp2x_video_RGB_flip(0);
while(count>0)
	{
	count--;
	gp2x_video_waitvsync();gp2x_video_RGB_flip(0);ClearScreen(COLORFONDO);
    
	y=2;
    v_putcad((40-15)/2,y,2,"GP2Xengine v1.3k5");y+=2;
    v_putcad((40-27)/2,y,2,"ported by Hermes/PS2Reality");y+=2;
    y+=2;
	v_putcad((40-21)/2,y,4,"Based on the work of:");y+=2;
	v_putcad((40-23)/2,y,4,"Marat Fayzullin/ Hu6280");y+=2;
	v_putcad((40-23)/2,y,4,"Alex Krasivsky / Hu6280");y+=2;
	v_putcad((40-11)/2,y,4,"BERO / fpce");y+=2;
	v_putcad((40-11)/2,y,4,"hmmx / XPCE");y+=2;
	v_putcad((40-15)/2,y,4,"Zeograd / Hu-Go");y+=2;
	v_putcad((40-20)/2,y,4,"rlyeh / GPX2 Min Lib");y+=2;
	v_putcad((40-13)/2,y,4,"BZIP2 library");y+=2;
	v_putcad((40-20)/2,y,4,"And Squidge MMU Hack");y+=2;
//	y+=3; 
	
	
	v_putcad((40-33)/2,y,2,"You are not allowed to distribute");y+=2; 
	v_putcad((40-26)/2,y,2,"this software commercially");y+=2;
   
    gp2x_nKeys=gp2x_joystick_read();

	if((gp2x_nKeys & (GP2X_A | GP2X_B | GP2X_X | GP2X_Y | GP2X_START))) 
		{while(gp2x_nKeys & (GP2X_A | GP2X_B | GP2X_X | GP2X_Y | GP2X_START)) gp2x_nKeys=gp2x_joystick_read();return;}

	}
while(gp2x_nKeys & (GP2X_A | GP2X_B | GP2X_X | GP2X_Y | GP2X_START)) gp2x_nKeys=gp2x_joystick_read();

}

static char t_button[8][16]={"Unused","Button I","Button II","Crazy","Crazy","Autofire I","Autofire II","Photo"};

int save_game();
int load_game(int modo);

int Config_SCR()
{

int old_speed;
int n,m,y,f,g;
int op=0;
unsigned new_key=0,old_key=0;
unsigned char cad[256];
int ret=0;

gp2x_sound_pause(1);
COLORFONDO=0;

SetVideoScaling(320,320,240);

set_mypalette();
ClearScreen(COLORFONDO);
old_speed=gp2x_speed;

g=0;
while(1)
{COLORFONDO=0;
 gp2x_video_waitvsync();gp2x_video_RGB_flip(0);ClearScreen(COLORFONDO);
    
    v_putcad(14,0,4,"CONFIGURATION");
	y=2;
    if(op==0) COLORFONDO=1; else COLORFONDO=0;
	sprintf(cad,"Change Speed: %uMhz",gp2x_speed);
	v_putcad(10,y,2,cad);y+=2;
	
	if(op==1) COLORFONDO=1; else COLORFONDO=0;
	sprintf(cad,"Bright Level: %u",mconfig.bright);
	v_putcad(10,y,2,cad);y+=2;

	if(op==2) COLORFONDO=1; else COLORFONDO=0;
	sprintf(cad,"Button A: %s",t_button[mconfig.A]);
	v_putcad(10,y,2,cad);y+=2;

	if(op==3) COLORFONDO=1; else COLORFONDO=0;
	sprintf(cad,"Button B: %s",t_button[mconfig.B]);
	v_putcad(10,y,2,cad);y+=2;

	if(op==4) COLORFONDO=1; else COLORFONDO=0;
	sprintf(cad,"Button X: %s",t_button[mconfig.X]);
	v_putcad(10,y,2,cad);y+=2;

	if(op==5) COLORFONDO=1; else COLORFONDO=0;
	sprintf(cad,"Button Y: %s",t_button[mconfig.Y]);
	v_putcad(10,y,2,cad);y+=2;

	if(op==6) COLORFONDO=1; else COLORFONDO=0;
	sprintf(cad,"Button L: %s",t_button[mconfig.L]);
	v_putcad(10,y,2,cad);y+=2;

	if(op==7) COLORFONDO=1; else COLORFONDO=0;
	sprintf(cad,"Button R: %s",t_button[mconfig.R]);
	v_putcad(10,y,2,cad);y+=2;

    if(op==8) COLORFONDO=1; else COLORFONDO=0;
/*	if(mconfig.video_inverted==2) v_putcad(10,y,2,"Change to Normal Screen"); 
	else if(mconfig.video_inverted==0) v_putcad(10,y,2,"Change to Vertical Screen");
	else if(mconfig.video_inverted==1) {v_putcad(10,y,2,"Change to Horizontal Down");COLORFONDO=0;v_putcad(1,29,4,"GPH, change the shit stick, please!!!");}
	*/
	if(mconfig.video_inverted==0) v_putcad(10,y,2,"Normal Screen"); 
	else if(mconfig.video_inverted==1) v_putcad(10,y,2,"Vertical Screen");
	else if(mconfig.video_inverted==2) {v_putcad(10,y,2,"Horizontal Inverse");COLORFONDO=0;v_putcad(1,29,4,"GPH, change the shit stick, please!!!");}
	y+=2;
	if(op==9) COLORFONDO=1; else COLORFONDO=0;
	v_putcad(10,y,2,"Save Game State");y+=2;

	if(op==10) COLORFONDO=1; else COLORFONDO=0;
	v_putcad(10,y,2,"Load Game State");y+=2;

	if(op==11) COLORFONDO=1; else COLORFONDO=0;
	v_putcad(10,y,2,"Game Exit");y+=2;

	if(op==12) COLORFONDO=1; else COLORFONDO=0;
	v_putcad(10,y,2,"Return");y+=2;

	
  usleep(KEYPAUSE); /* Pausa en milisegundos antes de leer el teclado (necesario tras aplicar mmu hack de Squidge)*/

    gp2x_nKeys=gp2x_joystick_read();
	
	new_key=gp2x_nKeys & (~old_key);
	old_key=gp2x_nKeys;  

    if(!(old_key  & (GP2X_UP | GP2X_DOWN))) g=0;
	if(old_key  & GP2X_UP)
		{
		if(g==0) g=2;
		else if(g & 1) g=2;
		else {g+=2;if(g>80) {g=68;new_key|=GP2X_UP;}}
		}
	if(old_key  & GP2X_DOWN)
		{
		if(g==0) g=1;
		else if(!(g & 1)) g=1;
		else {g+=2;if(g>81) {g=69;new_key|=GP2X_DOWN;}}
		}
    if(new_key & GP2X_UP) {op--;if(op<0) op=12;}
	if(new_key & GP2X_DOWN) {op++;if(op>12) op=0;}

	if(new_key & GP2X_Y) {break;}

	if(new_key & (GP2X_A | GP2X_PUSH | GP2X_X))
	{
	if(op==0)
		{
		switch(gp2x_speed)
			{
			case 150:gp2x_speed=166;break; 
			case 166:gp2x_speed=180;break; 
			case 180:gp2x_speed=200;break; 
			case 200:gp2x_speed=220;break; 
			case 220:gp2x_speed=240;break; 
			case 240:gp2x_speed=250;break; 
			case 250:gp2x_speed=266;break; 
			case 266:gp2x_speed=150;break; 
			}
		
		}
	if(op==1)
		{
		mconfig.bright++;mconfig.bright&=3;
		}

	if(op==2)
		{
		mconfig.A++;
		if(mconfig.A==3) mconfig.A=5;
		if(mconfig.A>7) mconfig.A=0;
		}
	if(op==3)
		{
		mconfig.B++;
		if(mconfig.B==3) mconfig.B=5;
		if(mconfig.B>7) mconfig.B=0;
		}
	if(op==4)
		{
		mconfig.X++;
		if(mconfig.X==3) mconfig.X=5;
		if(mconfig.X>7) mconfig.X=0;
		}
	if(op==5)
		{
		mconfig.Y++;
		if(mconfig.Y==3) mconfig.Y=5;
		if(mconfig.Y>7) mconfig.Y=0;
		}
	if(op==6)
		{
		mconfig.L++;
		if(mconfig.L==3) mconfig.L=5;
		if(mconfig.L>7) mconfig.L=0;
		}
	if(op==7)
		{
		mconfig.R++;
		if(mconfig.R==3) mconfig.R=5;
		if(mconfig.R>7) mconfig.R=0;
		}
	if(op==8) {mconfig.video_inverted++;if(mconfig.video_inverted>2) mconfig.video_inverted=0;}
	if(op==9)  {save_game();break;}
	if(op==10) {load_game(0);break;}
	if(op==11) {ret=1;break;}
	if(op==12) break;
	}
}
while(gp2x_nKeys & (GP2X_PUSH | GP2X_A | GP2X_B | GP2X_X | GP2X_Y | GP2X_START)) gp2x_nKeys=gp2x_joystick_read();
if(old_speed!=gp2x_speed) set_speed_clock();
set_emupalette();
gp2x_video_RGB_noflip(0); // single buffer screen
COLORFONDO=0;
ClearScreen(COLORFONDO);gp2x_video_waitvsync();
gp2x_sound_pause(0);
return ret;
}

void Loading_Encrypt_SCR()
{

int y,n;

set_mypalette();
COLORFONDO=0;
SetVideoScaling(320,320,240);

ClearScreen(COLORFONDO);
y=15;
v_putcad((40-21)/2,y,255,"Loading Encrypted ROM");
for(n=0;n<50;n++)
	gp2x_video_waitvsync();
   
set_emupalette();
}
////////////////////////////////////////////////////////////////////////7

int Main_Emulator(unsigned char * path_game);


 
static char rom_name[256]; // almacen del nombre: se utiliza porque en el caso de cargar un .sav, el nombre es reescrito

int main(int argc, char *argv[])
{
int i,r;
int dclock;

gp2x_init(1000,8,ds_nSampleRate*2,ds_nBits,ds_nChannels==2,50,1);

cpuctrl_init();  // ATENCION: si no se hace esto, cuelgue seguro (aprovecho la definicion de rlyeh y debe ir despues de gp2x_init)

Disable_940(); // desconecta el 940t
dclock=get_display_clock_div();
save_system_regs();
gp2x_speed=200;
set_speed_clock();
load_mconfig();
mconfig.video_inverted=0;
mount("-t vfat -o remount,sync,iocharset=utf8 /dev/mmcsd/disc0/part1 /mnt/sd");
//system("/bin/mount -t vfat -o remount,sync,iocharset=utf8 /dev/mmcsd/disc0/part1 /mnt/sd");
mkdir("/mnt/sd/roms",S_IREAD | S_IWRITE);
mkdir("/mnt/sd/roms/pcengine",S_IREAD | S_IWRITE);
mkdir("/mnt/sd/roms/pcengine/saves",S_IREAD | S_IWRITE);
mkdir("/mnt/sd/roms/pcengine/img",S_IREAD | S_IWRITE);

credits();

gp2x_sound_volume(volume,volume);
pthread_create( &wave_sound_thread, NULL, wave_sound_play, NULL);
while(1)
{
SetVideoScaling(320,320,240);

r=get_rom();
set_emupalette();

 if(r>=0) {di_sound=0;memcpy(rom_name,&files[r][0],256);Main_Emulator(rom_name); }
 else {if(r==-666)  {di_sound=0;Main_Emulator(0);} else break;}
 di_sound=1;
 
}
skip_wave_sound=1;
save_mconfig();
SetVideoScaling(320,320,240);


wave_sound_thread_exit=1; // asigna flag para liberar hilo de wav

Main_Emulator("\0"); // libera todo
gp2x_speed=200;
set_speed_clock();
ClearScreen(0);
gp2x_video_RGB_flip(0);
ClearScreen(0);
gp2x_video_RGB_flip(0);

gp2x_sound_pause(1);
gp2x_sound_volume(0,0);

load_system_regs();
set_display_clock_div(dclock);
gp2x_deinit();
return(0);

}
